from apps.warehouse.models import InventoryEntry, InventoryQuotaSaleTransaction
from apps.herd.services.services import rancher_quota_weight, get_rancher_statistics
from apps.core.models import SystemConfig
from django.db.models import Sum


def get_total_sold(inventory_entry, rancher):
    """
    """
    return (
            InventoryQuotaSaleTransaction.objects.filter(
                inventory_entry=inventory_entry,
                rancher=rancher
            ).aggregate(total=Sum('weight'))['total'] or 0
    )


def can_buy_from_inventory(rancher, inventory_entry: InventoryEntry):
    """
    """
    if SystemConfig.get("IGNORE_ALL_RANCHER_PURCHASE_LIMITS") == "true":
        return True

    if rancher.ignore_purchase_limit:
        return True

    quota_weight = rancher_quota_weight(rancher, inventory_entry)  # {total, by_type}
    total_allowed = quota_weight['total']

    total_sold = get_total_sold(inventory_entry, rancher)

    return total_sold < total_allowed
